#ifndef GUARD_FIFO
#define GUARD_FIFO
#include <cstddef>
#include "table.h"

class FIFO: public TABLE  {
double* _debut;
double* _fin;
public:
FIFO(size_t size = 16);
~FIFO();

double* end(){return _fin;};
double* rbegin(){return _debut;};
bool insert (double);
double pop (bool& popped);

};

#endif 
