#include <iostream>
#include "table.h"

using namespace std;

TABLE::TABLE(size_t size):_nb_elem(0),_size(size){
	_table = new double[_size];
	nb_table++;
	cerr << "Construction d'une TABLE de " << _size << " cases à l'adresse : "
	<< _table << " num " <<  nb_table << endl;
}

TABLE::~TABLE(){
	cerr << "Destruction de la table " <<  nb_table<<  " " << _table << endl;
	nb_table--;
	delete[] _table;
}

TABLE::TABLE(TABLE& t){
	_size = t.size_max();
	_table = new double[_size];
	_nb_elem = t.nb_element();

	for( size_t i = 0; i<=_nb_elem;i++)
		*(_table+i) = *(t.begin()+i);
	nb_table++;
    	
	cerr << "Construction d'une TABLE de " << _size << " cases à l'adresse : "
	<< _table << " num " <<  nb_table  << endl;

}
bool TABLE::insert (double value){
	if(_table+_nb_elem +1 <_table + _size)
	{
		cerr << "Ajout de " << value << " a l'adresse " << endl; 
		*(_table+(_nb_elem ++)) = value;
		return true;
	}
	else
		return false;
}
std::ostream& operator<<(std::ostream& o, const TABLE& t)
{
	if(t.nb_element() >0){
	o<< "TABLE : " << std::endl;
	const double* ptt = t.begin();
	o << *(ptt);
	for(size_t i = 1; i<t.nb_element();i++)
	{
		o << " | " << *(ptt+i) ;
	}
	o << std::endl;
	}
return o;
}

