
#include "fifo.h"
FIFO::FIFO(size_t size):TABLE(size){
 _debut = _table;
 _fin = _table;
}
FIFO::~FIFO(){}


bool FIFO::insert(double val)
{
	if(_nb_elem == _size)
	{
		return false;
	}
	else{
		std::cerr<< "ajout de " << val << std::endl;;
		*(_fin) = val;
		_nb_elem++;
		 if(_fin + 1 ==  _table+_size)
		    _fin = _table;
		else
		    _fin++;
		return true;
	}
}
double FIFO::pop(bool & popped)
{

	if(_nb_elem == 0)
	{
		popped=false;
		return 0;
	}
	else
	{
		popped = true;
		_nb_elem --;
		double val = *( _debut);
		if(_debut+1 == _table+_size)
			_debut = _table;
		else
			_debut++;
		return val;
	}
	
}
